##
## .clircrc.py for Teemu Kalvas <chery@s2.org>
##

import regex
from types import *

verbose = 1
motd = 0

irc_init = ('chery', 'Teemu Kalvas',
	    [([ #('gobi.s2.org', 6667),
		('irc.warwick.ac.uk', 6667),
		('irc.bt.net', 6664)
		],
	      ['cliini', 'p|rrliini', 'ilciin', 'cli'],
#	      ['#st'])])
	      ['#cokers', '#pallomeri', '#polonhoitoalue', '#st',
	       '#tahitibar', '#tampere', '#wanhat'])])

def _gen(obj):
    t = type(obj)
    if t == StringType:
	return obj
    elif t == ListType:
	go = map(_gen, obj)
	return '\(' + reduce(lambda x, y: x + '\|' + y, go[1:], go[0]) + '\)'
    elif t == TupleType:
	go = map(_gen, obj)
	return reduce(lambda x, y: x + y, go[1:], go[0])
    else:
	return ''

def gen(obj):
    return regex.compile(_gen(obj))

def _reload():
    global ops_all, ops

    ops = {}
    ops_all = gen(['.*@tjtk2\.trin\.cam\.ac\.uk',
		   'chery@a31b\.mtalo\.ton\.tut\.fi',
		   ('sandra@', ['hilavitkutin\.pp\.', 'borg\.'], 'sci\.fi')])
    ops['#cokers'] = \
        gen([('.*@', [(['.*\.', ''], 'vvf'),
		      (['o68b\.erkki', 'a29c\.otanner', 'f298b\.w3',
			(['a31b', 'a48b'], '\.mtalo'),
			(['g156b', 'h167', 'd67'], '\.lanhovi')],
		       '\.ton\.tut')], '\.fi'),
	     ([(['pekangas', 'hali', 'sly', 'sunnu'], '@',
		['assari', 'lehtori'], '\.cc'),
	       (['k153997', 'sunnu', 'c142092'], '.*\.cs')],
	      '\.tut\.fi')])
    ops['#pallomeri'] = \
	 gen((['tutoivo@kyopeli\.yok\.utu',
	      'lekoskin@kanto\.cc\.jyu',
	      'jma@one\.sci'], '\.fi'))
    ops['#polonhoitoalue'] = \
	 gen(([([(['mk@a5a\.ilmari', 'heikki@a30b\.keihas',
		   '.*@a17a\.mannikko3'], '\.ton'),
		 ([('nelle@', ['assari', 'lehtori']),
		   'petrus@kaimas.*'], '\.cc')], '\.tut'),
	       (['.?katja', '.?alik'], '@niiranet\.iwn'),
	       (['.?mikki@hoover', '.*@ankkuli'], '\.elma'),
	       (['mo61129', 'tl55203', 'ja56375'], '@vuokko\.uta'),
	       'kakuusis@hytti\.uku', 'af@silmu\.microdata',
	       'mertsi@kianto\.suomussalmi', 'haha@gamma\.hut',
	       'ceres@wopr\.sci', 'warhol@nomad.*\.tpu',
	       '.?hamberg@myntti\.helsinki', '.?roope@kani\.noitatieto',
	       (['kujopa', 'lekoskin', 'maralap', 'ktcat'], '@.*\.',
		['cc', 'st'], '\.jyu')], '\.fi'))
    ops['#st'] = \
	gen([('.*@', [(['.*\.', ''], 'one\.sci\.fi'), 'joon\.as',
		      (['colin', 'jermaine'], '\.works\.fi')]),
	     (['nysv@blah\.union',
	       ('joonas@', ['union', 'wopr'])], '\.sci\.fi'),
	     (['mka', 'jak'], '@am\.fm\.org'),
	     ('mka@', ['.*\.', ''], ['magenta\.net', 'satama\.com'])])
    ops['#tampere'] = \
	gen([([('.*@', ['.*\.', ''], 'luo'),
	       '.?ristok@.*\.cyberpark',
	       '.?rko@rko\.vip\.best'], '\.com'),
	     ([('seaga@', ['.*\.', ''], 'seaga'),
	       ('.?sumppi@', ['.*\.', ''], 'nlf-finland'),
	       ('.?jam@', ['.*\.', ''], 'jam')], '\.org'),
	     '.?juha@kaunis\.to',

	     ([(['.?nuppunen', '.?leponiem'], '@.*\.helsinki'),
	       (['.?jkoikkal', '.?koppinen'], '@.*\.uku'),
	       (['.?juha', '.?loora', '.?riku'], '@.*\.sgic'),
	       (['.?ruxu', 'riku'], '@.*\.vip'),
	       (['.?jakke', '.?mtaj'], '@.*\.tpo'),

	       '.?d74447@.*\.uwasa', '.?Roni@.*\.solid', '.?ketesi@.*\.jyu',
	       '.?keinanen@.*\.nokia', 'tvoansa@info2\.info\.tampere',
	       '.?ruxu@.*\.tampere\.pcss', 'ketesi@.*\.oulu',
	       '.?y95rmatu@.*\.kotakk', '.?mta@.*\.magic', 'jkoikkal@.*\.iwn',
	       '.?masalon@.*\.inet', '.?hazor@.*\.hut', '.?hmm@.*\.elma',
	       'acviki@.*\.tpu',

	       (['lostgr', '.?tl55203', 'ml54642', 'jv54750', '.?ms58455',
		 '.?riku', 'pa56057', '.?rh59161', '.?timime', '.?mh56522',
		 '.?tl55203', '.?mr54152', '.?jr54317', '.?ar56112',
		 '.?le56153', '.?nn58143', '.?jl57162', '.?ja56375', '.?noran',
		 '.?pk56727'], '@.*\.uta\.fi'),

	       ([(['.?horny@j192c\.lanhovi',
		   (['.?ofelia', '.?lassek'], '@a29c\.otanner'),
		   'arusalmi@h29\.erkki', 'heikki@a30b\.keihas'], '\.ton'),
		 (['k151709', 'hkulmala'], '@', ['assari', 'lehtori'], '\.cc'),
		 (['k124468', 'hsarkka'], '@.*\.cs'),
		 (['.?vpe', '.?heikki', '.?janna', '.?lina@', 'asalmine',
		   '.?s151924', '.?lassek', '.?ace', '.?jakke', '.?h112771',
		   '.?r151431', '.?vis', '.?matrix', '.?r152058', '.?h154134',
		   '.?akim', '.?tuulia'], '@.*')], '\.tut\.fi'),

	       ([(['seaga', 'sch'], '@',
		  ['staff', 'starbuck', 'lcars', 'robbie', '42', 'borg', ''],
		  '\.'),
		 ('.?mta@', ['mta\.pp', 'borg', '']),
		 (['teheino', 'haggai', '.?riku', 'trio', 'rko'],
		  '@', ['borg', ''], '\.'),
		 (['.?wisp', '.?sumppi', 'neuro', 'seaga', '.?uucee', '.?tepi',
		   'vndr', 'turto', '.?jma', '.?vuori', '.?cicca', '.?anttik'],
		  '@', ['.*\.', ''], 'one\.')], 'sci\.fi')] ,'\.fi')])

def autoop(addr, chan):
    return ops_all.match(addr) > 0 or \
	   (ops.has_key(chan) and ops[chan].match(addr) > 0)

## End. ##
